package geniusweb.logconverter;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.List;
import java.util.logging.Level;

import org.junit.Test;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;

public class ConvertTest {
	TestReporter reporter = new TestReporter();

	@Test
	public void e2esmoketest() {
		Convert.main(new String[] { "-s",
				"src/test/resources/APP1646925947841local.json", "-f", "CSV" });
	}

	@Test
	public void e2eTest()
			throws JsonParseException, JsonMappingException, IOException {
		new Convert(new File("src/test/resources/APP1646925947841local.json"),
				Level.WARNING, null, Convert.Format.CSV, reporter);
		assertEquals(null, reporter.getError());
	}

	@Test
	public void e2eToFile() throws IOException {
		File outfile = File.createTempFile("temp", "csv");
		outfile.delete();
		new Convert(new File("src/test/resources/APP1646925947841local.json"),
				Level.WARNING, outfile, Convert.Format.CSV, reporter);
		assertEquals(null, reporter.getError());
		List<String> lines = Files.readAllLines(outfile.toPath());
		assertEquals(37, lines.size());
		lines.remove(0); // remove header line.
		int row = 0;
		for (String line : lines) {
			String[] cols = line.split(",");
			Integer session = Integer.valueOf(cols[0]);
			assertEquals((Integer) (row / 2), session);
			assertTrue(Double.valueOf(cols[3]) > 0); // all utils valid
			row++;
		}
		outfile.delete();
	}

}